/******************************************************************
 *
 *  EE-164 example code
 *  primitive overlay manager that does NOT take advantage
 *  of DMA. Refer to EE-152 for rea-world overlay managers.
 *
 *  ANALOG DEVICES INC. (bk) 2002
 *
 ******************************************************************/


.global _ovl_man;
.global _ovl_id;
.global _ovl_addr;

/********************************************************************/

.import "overlays.h";
#include "overlays.h";

.section / data data1;


.extern OVL_EXTERNALS(1);
.extern OVL_EXTERNALS(2);
.extern OVL_EXTERNALS(3);
.extern OVL_EXTERNALS(4);

.struct ovl_struct _ovl_tab[] = {
	OVL_STRUCT_INIT(1),
	OVL_STRUCT_INIT(2),
	OVL_STRUCT_INIT(3),
	OVL_STRUCT_INIT(4)
};

.var _ovl_id;
.var _ovl_addr; 
.var _ovl_loaded = -1;
.var _save_dmpg2;
.var _run_addr;

/********************************************************************/
/* For demonstration this is a very basic overlay manager. 
 * It uses core instructions to load overlays into on-chip 
 * memory rather than DMA. Please refer to EE-??? for 
 * real-world managers.
 */

/* this simple example assumes 
 *	 dmpg1 = 0
 *   iopg = 0
 *   l4 = 0;
 *   l2 = 0;
 *	 run space in page 0
 *	 _ovl_tab in page 0
 *
 * input parameters
 *   ar = overlay_id
 *   ay0 = run address
 */
 
.section / code program;
_ovl_man:
	
	dm(_run_addr) = ay0;
	ay0 = dm(_ovl_loaded);
	ar - ay0;
	if eq rts;
	
	dm(_ovl_loaded) = ar;	
	i4 = _ovl_tab - sizeof(ovl_struct);
	
	ay0 = dmpg2;
	dm(_save_dmpg2) = ay0;
	dmpg2 = 0;
  	m4 = sizeof(ovl_struct);	
	cntr = ar;  	
 	do getstructaddr until ce;
getstructaddr: modify(i4+=m4);	
	
	ar = dm(i4+offsetof(ovl_struct,run_size));
	cntr = ar;	
	ay0 = dm(i4+offsetof(ovl_struct,run_addr));
	i2 = ay0; 	
	ar = dm(i4+offsetof(ovl_struct,live_addr));		
	ay0 = dm(i4+offsetof(ovl_struct,live_page));
	dmpg2 = ay0;
	i4 = ar;
	m4 = 1;
	m2 = 1;
	
	do loadovl until ce;
		 ar = pm(i4+=m4);		 
loadovl: pm(i2+=m2)=ar;	
		
	i4 = dm(_run_addr);
	flush cache;	
	jump (i4) (db);				
		ay0 = dm(_save_dmpg2);
		dmpg2 = ay0;		
		
	
		
